/* Problem URL: https://codeforces.com/problemset/problem/1833/G */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n;
    cin >> n;

    V<set<pair<int, int>>> graph(n);

    nrep(i, 1, n) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        graph[a].emplace(b, i);
        graph[b].emplace(a, i);
    }

    set<int> er;

    bool pos = true;
    function<int(int, int)> dfs = [&](int i, int p) {
        int c = 0;
        auto cur = graph[i].begin();
        while (cur != graph[i].end()) {
            auto [j, ind] = *cur;
            graph[i].erase({j, ind});
            cur = graph[i].begin();

            if (graph[j].size() != 1) {
                graph[j].erase({i, ind});
                int res = dfs(j, ind);
                if (res == 0) {
                    c++;
                    continue;
                }

                if (res == 1) {
                    if (c != 0) {
                        pos = false;
                        return 2;
                    }

                    for (auto [k, _] : graph[i]) {
                        er.insert(_);
                        graph[k].erase({i, _});
                        if (dfs(k, _) != 2) {
                            pos = false;
                            return 0;
                        }
                    }

                    return 2;
                }

                er.insert(ind);
                continue;
            }

            c++;
        }

        if (c > 2) {
            pos = false;
            return 0;
        }

        return c;
    };

    if (dfs(0, -1) != 2 || !pos) {
        cout << "-1\n";
        return;
    }

    er.erase(0);

    cout << er.size() << '\n';
    repv(i, er) {
        cout << i << ' ';
    }
    cout << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
